export function tabs(doc) {
  return {
    accounts: {
      svg_icon:
        '<svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-brand-firebase" width="44" height="44" viewBox="0 0 24 24" stroke-width="1.5" stroke="#2c3e50" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M4.53 17.05l6.15 -11.72h-.02c.38 -.74 1.28 -1.02 2.01 -.63c.26 .14 .48 .36 .62 .62l1.06 2.01" /><path d="M15.47 6.45c.58 -.59 1.53 -.59 2.11 -.01c.22 .22 .36 .5 .41 .81l1.5 9.11c.1 .62 -.2 1.24 -.76 1.54l-6.07 2.9c-.46 .25 -1.01 .26 -1.46 0l-6.02 -2.92c-.55 -.31 -.85 -.92 -.75 -1.54l1.96 -12.04c.12 -.82 .89 -1.38 1.7 -1.25c.46 .07 .87 .36 1.09 .77l1.24 1.76" /><path d="M4.57 17.18l10.93 -10.68" /></svg>',
      text: "Accounts",
      type: "single",
      columns: [
        { id: "columnA", title: "Project Info", column_size: 6 },
        { id: "columnB", title: "Firebase Config", column_size: 6 },
      ],
      fields: {
        apiKey: {
          type: "string",
          placeholder: "AIzaSyAG1feuoBLw8S07S9muVIryR-LPJQIUYIUH",
          mandatory: true,
          label: "Api Key",
          size: 12,

          column: "columnB",
        },
        authDomain: {
          type: "string",
          placeholder: "xuda-io.firebaseapp.com",
          mandatory: true,
          label: "Auth Domain",
          size: 12,
          column: "columnB",
        },
        projectId: {
          type: "string",
          placeholder: "xuda-io",
          mandatory: true,
          label: "Project Id",
          size: 12,
          column: "columnB",
        },
        storageBucket: {
          type: "string",
          placeholder: "xuda-io.appspot.com",
          mandatory: true,
          label: "Storage Bucket",
          size: 12,
          column: "columnB",
        },
        messagingSenderId: {
          type: "string",
          placeholder: "960548124335",
          mandatory: true,
          label: "Messaging Sender Id",
          size: 12,
          column: "columnB",
        },
        appId: {
          type: "string",
          placeholder: "1:961248124231:web:005cba365g14bea105c43d",
          mandatory: true,
          label: "App Id",
          size: 12,
          column: "columnB",
        },
        measurementId: {
          type: "string",
          placeholder: "G-02EFRQLBZS",
          mandatory: true,
          label: "Measurement Id",
          size: 12,

          column: "columnB",
        },
        projectNumber: {
          type: "string",
          placeholder: "960548124335",
          mandatory: true,
          label: "Project Number",
          size: 12,
          tooltip:
            "The globally unique, Google-assigned canonical identifier for your Firebase project. Use this identifier when configuring integrations and/or making API calls to Firebase or third-party services.",
          column: "columnA",
        },
        webApiId: {
          type: "string",
          placeholder: "AIzaSyAG1feuoBLw8S07S9muVIryR-LPJQIUYIUH",
          mandatory: true,
          label: "Web Api Key",
          size: 12,
          column: "columnA",
        },
      },
    },
  };
}
